#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const commander_1 = require("commander");
const playwright_1 = require("playwright");
// import { generate } from "./generate";
const program = new commander_1.Command();
program
    .requiredOption("-i, --input <input>", "input text file")
    .requiredOption("-o, --output <output>", "output svg file");
program.parse(process.argv);
const { input, output } = program.opts();
const outputPath = path_1.default.resolve(process.cwd(), output);
const text = fs_1.default.readFileSync(path_1.default.resolve(process.cwd(), input), "utf-8");
(() => __awaiter(void 0, void 0, void 0, function* () {
    const browser = yield playwright_1.chromium.launch();
    const context = yield browser.newContext({ acceptDownloads: true });
    // Open new page
    const page = yield context.newPage();
    // Go to https://flowchart.fun/
    yield page.goto("https://flowchart.fun/?animation=0");
    yield page.evaluate((t) => {
        // @ts-ignore
        window.flowchartFunSetText(t);
    }, text);
    yield page.waitForTimeout(300);
    // Click text=Download SVG
    const [download] = yield Promise.all([
        page.waitForEvent("download"),
        page.click("text=Download SVG"),
    ]);
    yield download.saveAs(outputPath);
    // ---------------------
    yield context.close();
    yield browser.close();
}))();
